SystemOrganization addCategory: #'SourceCity-OpenGL'!

!NBGLDisplay methodsFor: '*SourceCity-OpenGL' stamp: 'DouailleErwan 5/22/2012 11:27'!
readPixel: aPoint

      |  x y pixel |
	pixel := ByteArray new: 4.

	x := aPoint x asInteger.
	y := aPoint y asInteger.
	
	"Copy pixels from buffer into a form"
	self gl flush;
		pixelStorei_pname: GL_PACK_SKIP_ROWS param: 0;
		pixelStorei_pname: GL_PACK_SKIP_PIXELS param: 0;
		
		readPixels_x: x
		y: y
		width: 1  
		height: 1  
		format: GL_BGRA_EXT 
		type:  GL_UNSIGNED_BYTE 
		pixels: pixel.

	^ pixel
	! !

!NBMSAAOffscreenDisplay methodsFor: '*SourceCity-OpenGL' stamp: 'DouailleErwan 5/22/2012 11:35'!
readPixel: aPoint
	| r |

	renderFBO bindAsReadBuffer.
	resultsFBO bindAsDrawBuffer.
	
	self gl blitFramebuffer_srcX0: 0 srcY0:  0 srcX1: extent x srcY1: extent y 
		dstX0:  0 dstY0:  0 dstX1: extent x  dstY1: extent y mask: GL_COLOR_BUFFER_BIT filter: GL_NEAREST.
	
	resultsFBO bindAsReadBuffer.
		
	r := super readPixel: aPoint.
	^ r! !

GLViewportMorph subclass: #SourceCityGL
	instanceVariableNames: 'sourceCityConfiguration pickingBuf camera controller drawing userInterface renderer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-OpenGL'!

!SourceCityGL commentStamp: '<historical>' prior: 0!
A GLCity is a class which display the city with OpenGL, this class use camera and key handler!

!SourceCityGL class methodsFor: 'as yet unclassified' stamp: 'blo 7/5/2012 13:28'!
sourceCityConfiguration: aSourceCityConfiguration
	^self new sourceCityConfiguration: aSourceCityConfiguration! !

!SourceCityGL methodsFor: 'accessing' stamp: 'blo 7/9/2012 12:16'!
camera
	^ camera! !

!SourceCityGL methodsFor: 'accessing' stamp: 'blo 7/9/2012 12:01'!
camera: anObject

	camera := anObject! !

!SourceCityGL methodsFor: 'accessing' stamp: 'blo 7/9/2012 12:01'!
controller

	^ controller! !

!SourceCityGL methodsFor: 'accessing' stamp: 'blo 7/9/2012 12:01'!
controller: anObject

	controller := anObject! !

!SourceCityGL methodsFor: 'accessing' stamp: 'blo 7/9/2012 12:18'!
display 
	^display! !

!SourceCityGL methodsFor: 'accessing' stamp: 'blo 7/9/2012 12:01'!
drawing

	^ drawing! !

!SourceCityGL methodsFor: 'accessing' stamp: 'blo 7/9/2012 12:01'!
drawing: anObject

	drawing := anObject! !

!SourceCityGL methodsFor: 'events-handling' stamp: 'DouailleErwan 6/20/2012 11:24'!
handleMouseMove: anEvent
	self controller handleMouseMove: anEvent
! !

!SourceCityGL methodsFor: 'events-handling' stamp: 'DouailleErwan 6/20/2012 11:37'!
handlesMouseOver: anEvent
	^ true! !

!SourceCityGL methodsFor: 'events-handling' stamp: 'DouailleErwan 6/20/2012 11:37'!
hasKeyboardFocus
	^true.! !

!SourceCityGL methodsFor: 'initialize' stamp: 'blo 7/9/2012 12:14'!
initialize
	| fontPath |
	super initialize.
	
	self controller: (SourceCityGLController initialize: self).
	self drawing: (SourceCityGLVizualisationBuilder initialize: self).
	self userInterface: (SourceCityUI initialize: self).
	self renderer: (SourceCityGLVizualisationRenderer initialize: self ).
	
	self on: #keyStroke send: #captureKey: to: self controller.
	self on: #mouseDown send: #captureMouseDown: to: self controller.	
		
	! !

!SourceCityGL methodsFor: 'events-handling' stamp: 'DouailleErwan 6/20/2012 11:37'!
mouseEnter: anEvent
	anEvent hand newKeyboardFocus: self! !

!SourceCityGL methodsFor: 'events-handling' stamp: 'DouailleErwan 6/20/2012 11:37'!
mouseLeave: anEvent
	anEvent hand newKeyboardFocus: nil! !

!SourceCityGL methodsFor: 'initialize' stamp: 'DouailleErwan 6/25/2012 10:30'!
openInWorld
	|dock container win |
	self startStepping.
	self takeKeyboardFocus.
	self userInterface openInWorld.! !

!SourceCityGL methodsFor: 'accessing' stamp: 'blo 7/9/2012 12:01'!
pickingBuf

	^ pickingBuf! !

!SourceCityGL methodsFor: 'accessing' stamp: 'blo 7/9/2012 12:01'!
pickingBuf: anObject

	pickingBuf := anObject! !

!SourceCityGL methodsFor: 'rendering' stamp: 'blo 7/9/2012 11:14'!
render
	self renderer render! !

!SourceCityGL methodsFor: 'accessing' stamp: 'blo 7/9/2012 12:01'!
renderer

	^ renderer! !

!SourceCityGL methodsFor: 'accessing' stamp: 'blo 7/9/2012 12:01'!
renderer: anObject

	renderer := anObject! !

!SourceCityGL methodsFor: 'accessing' stamp: 'blo 7/9/2012 12:01'!
sourceCityConfiguration

	^ sourceCityConfiguration! !

!SourceCityGL methodsFor: 'accessing' stamp: 'blo 7/9/2012 12:17'!
sourceCityConfiguration: anObject

	sourceCityConfiguration := anObject.
	self camera:(SourceCityGLCamera initialize: self camera: self sourceCityConfiguration camera). 
! !

!SourceCityGL methodsFor: 'stepping and presenter' stamp: 'DouailleErwan 6/18/2012 10:24'!
step
	self changed! !

!SourceCityGL methodsFor: 'stepping and presenter' stamp: 'DouailleErwan 6/18/2012 10:24'!
stepTime
	^5! !

!SourceCityGL methodsFor: 'accessing' stamp: 'blo 7/9/2012 12:01'!
userInterface

	^ userInterface! !

!SourceCityGL methodsFor: 'accessing' stamp: 'blo 7/9/2012 12:01'!
userInterface: anObject

	userInterface := anObject! !

GLViewportMorph subclass: #SourceCityGLVizualisationBuilder
	instanceVariableNames: 'sourceCityGL idDictionary id city glList glListPicking'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-OpenGL'!

!SourceCityGLVizualisationBuilder commentStamp: 'blo 7/9/2012 11:11' prior: 0!
I manage how to create the city vizualisation.!

!SourceCityGLVizualisationBuilder class methodsFor: 'as yet unclassified' stamp: 'blo 7/9/2012 11:48'!
initialize: aSourceCityGL
	^self new sourceCityGL: aSourceCityGL! !

!SourceCityGLVizualisationBuilder methodsFor: 'accessing' stamp: 'blo 7/9/2012 12:25'!
city
	city ifNil: [self city: sourceCityGL sourceCityConfiguration city].
	^ city! !

!SourceCityGLVizualisationBuilder methodsFor: 'accessing' stamp: 'blo 7/5/2012 14:06'!
city: aCity
	city := aCity.
	self createIdDictionary: aCity! !

!SourceCityGLVizualisationBuilder methodsFor: 'drawing' stamp: 'blo 7/5/2012 14:25'!
colorFor: anElement
	| r g b |
	r := anElement color red.
	g := anElement color green.
	b := anElement color blue.
	display gl color3f_red: r green: g blue: b! !

!SourceCityGLVizualisationBuilder methodsFor: 'drawing' stamp: 'blo 7/5/2012 15:47'!
colorInPickingModeFor: anElement
	| elementId r g b |
	elementId := idDictionary keyAtValue: anElement.
	r := elementId bitAnd: 255.
	g := elementId >> 8 bitAnd: 255.  " elementId // (2^8) "
	b := elementId >>16 bitAnd: 255.
	display gl color3ub_red:  r green: g  blue:  b.! !

!SourceCityGLVizualisationBuilder methodsFor: 'tools' stamp: 'blo 7/5/2012 15:00'!
createIdDictionary: aCity
	idDictionary := Dictionary new.
	idDictionary at: (self generateId) put: aCity.
	aCity districts do:[:aDistrict | idDictionary at: (self generateId) put: aDistrict.
		aDistrict buildings do: [:aBuilding | idDictionary at: (self generateId) put: aBuilding]].! !

!SourceCityGLVizualisationBuilder methodsFor: 'buildList' stamp: 'blo 7/9/2012 11:45'!
createLists
	self createNormalRenderingList.
	self createPickingRenderingList.! !

!SourceCityGLVizualisationBuilder methodsFor: 'buildList' stamp: 'blo 7/9/2012 11:42'!
createNormalRenderingList
	self glList: (display gl genLists: 1).
	self fillRenderingList: (self glList) pickingMode: false. ! !

!SourceCityGLVizualisationBuilder methodsFor: 'buildList' stamp: 'blo 7/9/2012 11:42'!
createPickingRenderingList
	self glListPicking: (display gl genLists: 2).
	self fillRenderingList: (self glListPicking) pickingMode: true. ! !

!SourceCityGLVizualisationBuilder methodsFor: 'drawing' stamp: 'blo 7/9/2012 11:49'!
disableOpenGLOption
	
	display gl 		
		enable: GL_MULTISAMPLE ;
		disable: GL_BLEND;
		disable: GL_POLYGON_SMOOTH;
		disable: GL_NORMALIZE;
		clearDepth: 1; 
	 	enable: GL_DEPTH_TEST;
		depthFunc: GL_LEQUAL;
		depthMask: true.		! !

!SourceCityGLVizualisationBuilder methodsFor: 'draw-polygon' stamp: 'blo 7/4/2012 16:48'!
drawBack: aPoint vector3D: aVector
	display gl begin: GL_QUADS;
		vertex3d_x:  aPoint x 
			y: aPoint y 
			z: (aPoint z)+(aVector z);
		vertex3d_x:  (aPoint x)+(aVector x) 
			y: aPoint y 
			z: (aPoint z)+(aVector z);
		vertex3d_x:  (aPoint x)+(aVector x) 
			y: aPoint y + (aVector y)
			z: (aPoint z)+(aVector z);
		vertex3d_x:  aPoint x 
			y: aPoint y + (aVector y)
			z: (aPoint z)+(aVector z);
	end.! !

!SourceCityGLVizualisationBuilder methodsFor: 'draw-polygon' stamp: 'blo 7/4/2012 16:48'!
drawBorder: aPoint vector3D: aVector
	display gl begin: GL_LINE_STRIP;
		color3f_red: 0 green: 0 blue: 0; 
		vertex3f_x: (aPoint x) + (aVector x)
			y: (aPoint y) 
			z: (aPoint z);
		vertex3f_x: (aPoint x) + (aVector x)
			y: (aPoint y) + (aVector y)
			z: (aPoint z);
		vertex3f_x: (aPoint x) + (aVector x)
			y: (aPoint y) + (aVector y)
			z: (aPoint z) + (aVector z);
		vertex3f_x: (aPoint x)
			y: (aPoint y) + (aVector y)
			z: (aPoint z) + (aVector z);
		vertex3f_x: (aPoint x)
			y: (aPoint y) + (aVector y)
			z: (aPoint z);
		vertex3f_x: (aPoint x)
			y: (aPoint y)
			z: (aPoint z);
		vertex3f_x: (aPoint x) + (aVector x)
			y: (aPoint y)
			z: (aPoint z);
		vertex3f_x: (aPoint x) + (aVector x)
			y: (aPoint y)
			z: (aPoint z)+ (aVector z);
		vertex3f_x: (aPoint x)
			y: (aPoint y)
			z: (aPoint z)+ (aVector z);
		vertex3f_x: (aPoint x)
			y: (aPoint y)
			z: (aPoint z);
	end.
	display gl begin: GL_LINES;
		color3f_red: 0 green: 0 blue: 0; 
		vertex3f_x: (aPoint x)
			y: (aPoint y) + (aVector y)
			z: (aPoint z);
		vertex3f_x: (aPoint x) + (aVector x)
			y: (aPoint y) + (aVector y)
			z: (aPoint z);
		vertex3f_x: (aPoint x)
			y: (aPoint y)
			z: (aPoint z) + (aVector z);
		vertex3f_x: (aPoint x)
			y: (aPoint y) + (aVector y)
			z: (aPoint z) + (aVector z);
		vertex3f_x: (aPoint x) + (aVector x)
			y: (aPoint y)
			z: (aPoint z) + (aVector z);
		vertex3f_x: (aPoint x) + (aVector x)
			y: (aPoint y) + (aVector y)
			z: (aPoint z) + (aVector z);
		end.! !

!SourceCityGLVizualisationBuilder methodsFor: 'drawing' stamp: 'blo 7/9/2012 12:23'!
drawCityWithPicking: aBoolean
	self drawCube: self city pickingMode: aBoolean.
	self city districts do: [:aDistrict | self drawDistrict: aDistrict pickingMode: aBoolean].
	! !

!SourceCityGLVizualisationBuilder methodsFor: 'draw-polygon' stamp: 'blo 7/9/2012 11:31'!
drawCube: anElement pickingMode: aBoolean
	| aPosition aDimension |
	aPosition := anElement absolutePosition.
	aDimension := anElement dimension.
	
	(aBoolean)
	ifTrue: [self colorInPickingModeFor: anElement] 
	ifFalse: [self colorFor: anElement].
	
	self drawFace: aPosition vector3D: aDimension.
	self drawBack: aPosition vector3D: aDimension.
	self drawLeft: aPosition vector3D: aDimension.
	self drawRight: aPosition vector3D: aDimension.
	self drawDown: aPosition vector3D: aDimension.
	self drawTop: aPosition vector3D: aDimension.
	
	(self pickingMode)
		ifFalse: [self drawBorder: aPosition vector3D: aDimension.].! !

!SourceCityGLVizualisationBuilder methodsFor: 'drawing' stamp: 'blo 7/9/2012 11:33'!
drawDistrict: aDistrict pickingMode: aBoolean
	
	self drawCube: aDistrict pickingMode: aBoolean. 
	
	aDistrict buildings do:[:aBuilding |
		self drawCube: aBuilding pickingMode: aBoolean.
		]! !

!SourceCityGLVizualisationBuilder methodsFor: 'draw-polygon' stamp: 'blo 7/4/2012 16:50'!
drawDown: aPoint vector3D: aVector
	display gl begin: GL_QUADS;
		vertex3d_x:  (aPoint x) 
			y: (aPoint y) 
			z: (aPoint z);
		vertex3d_x:  (aPoint x)+(aVector x) 
			y: (aPoint y)
			z: (aPoint z);
		vertex3d_x:  (aPoint x)+(aVector x) 
			y: (aPoint y)
			z: (aPoint z)+(aVector z);
		vertex3d_x:  (aPoint x) 
			y: (aPoint y)
			z: (aPoint z)+(aVector z);
	end.! !

!SourceCityGLVizualisationBuilder methodsFor: 'draw-polygon' stamp: 'blo 7/4/2012 16:50'!
drawFace: aPoint vector3D: aVector
	display gl begin: GL_QUADS;
		vertex3d_x: (aPoint x) 
			y: (aPoint y) 
			z: (aPoint z);
		vertex3d_x: (aPoint x) 
			y: (aPoint y) + (aVector y)
			z: (aPoint z);
		vertex3d_x: (aPoint x)+(aVector x) 
			y: (aPoint y) + (aVector y)
			z: (aPoint z);
		vertex3d_x: (aPoint x)+(aVector x) 
			y: (aPoint y) 
			z: (aPoint z);
	end.! !

!SourceCityGLVizualisationBuilder methodsFor: 'draw-polygon' stamp: 'blo 7/4/2012 16:50'!
drawLeft: aPoint vector3D: aVector
	display gl begin: GL_QUADS;
		vertex3d_x:  (aPoint x)+(aVector x) 
			y: (aPoint y)
			z: (aPoint z);
		vertex3d_x:  (aPoint x)+(aVector x) 
			y: (aPoint y) + (aVector y)
			z: (aPoint z);
		vertex3d_x:  (aPoint x)+(aVector x) 
			y: (aPoint y) + (aVector y)
			z: (aPoint z)+(aVector z);
		vertex3d_x:  (aPoint x)+(aVector x) 
			y: (aPoint y)
			z: (aPoint z)+(aVector z);
	end.! !

!SourceCityGLVizualisationBuilder methodsFor: 'draw-polygon' stamp: 'blo 7/4/2012 16:50'!
drawRight: aPoint vector3D: aVector
	display gl begin: GL_QUADS;
		vertex3d_x:  (aPoint x) 
			y: (aPoint y)
			z: (aPoint z)+(aVector z);
		vertex3d_x:  (aPoint x) 
			y: (aPoint y) + (aVector y)
			z: (aPoint z)+(aVector z);
		vertex3d_x:  (aPoint x) 
			y: (aPoint y) + (aVector y)
			z: (aPoint z) ;
		vertex3d_x:  (aPoint x) 
			y: (aPoint y)
			z: (aPoint z) ;
	end.! !

!SourceCityGLVizualisationBuilder methodsFor: 'draw-polygon' stamp: 'blo 7/4/2012 16:50'!
drawTop: aPoint vector3D: aVector
	display gl begin: GL_QUADS;
		vertex3d_x: (aPoint x) 
			y: (aPoint y) + (aVector y)
			z: (aPoint z) ;
		vertex3d_x: (aPoint x) 
			y: (aPoint y) + (aVector y)
			z: (aPoint z)+(aVector z);
		vertex3d_x: (aPoint x)+(aVector x) 
			y: (aPoint y) + (aVector y)
			z: (aPoint z)+(aVector z);
		vertex3d_x: (aPoint x)+(aVector x) 
			y: (aPoint y) + (aVector y)
			z: (aPoint z) ;
	end.! !

!SourceCityGLVizualisationBuilder methodsFor: 'drawing' stamp: 'blo 7/9/2012 11:49'!
enableOpenGLOption
	
	display gl 		
		enable: GL_MULTISAMPLE ;
		enable: GL_BLEND;
		enable: GL_POLYGON_SMOOTH;
		enable: GL_NORMALIZE;
		clearDepth: 1; 
	 	enable: GL_DEPTH_TEST;
		shadeModel: GL_SMOOTH;
		hint_target: GL_LINE_SMOOTH_HINT mode: GL_FASTEST;
		hint_target: GL_POLYGON_SMOOTH_HINT mode: GL_FASTEST;
		hint_target: GL_PERSPECTIVE_CORRECTION_HINT mode: GL_NICEST;
		depthFunc: GL_LEQUAL;
		depthMask: true.		
	"save it there for the moment :)"
	"WORK !!!!!!!!"
	"specular := GLFloatRGBA new.
	specular r: 1; g: 1;b: 1; a:1. 
	shinines:= GLFloatRGBA new.
	shinines r: 500. 	
	l_pos := GLFloatVector new.
	l_pos x: 0 ;y: 0;z: 0. 
	l_color := GLFloatRGBA new.
	l_color r: 1; g: 1;b: 1; a:1. 			
	lmodel_ambient := GLFloatRGBA new.
	lmodel_ambient r: 1;g: 1 ;b: 1; a:1."
	
	"fog_color := GLFloatRGBA new.
	fog_color r: 0.5; g: 0.5;b: 0.5; a:1. "
		
		"FOG"
		"enable: GL_FOG;
		fogi_pname: GL_FOG_MODE param: GL_EXP2;
		fogfv_pname: GL_FOG_COLOR params: fog_color;
		fogf_pname: GL_FOG_DENSITY param: 0.01;
		hint_target: GL_FOG_HINT mode: GL_DONT_CARE;
		fogf_pname: GL_FOG_START param: 1.0;
		fogf_pname: GL_FOG_END param: 5.0;"
		
		"LIGHT"
		"materialfv_face: GL_FRONT pname: GL_SPECULAR params: specular;
		materialfv_face: GL_FRONT pname: GL_SHININESS  params: shinines;
		lightfv_light: GL_LIGHT0 pname: GL_POSITION params: l_pos;
		lightfv_light: GL_LIGHT0 pname: GL_DIFFUSE params: l_color;
		lightfv_light: GL_LIGHT0 pname: GL_SPECULAR params: l_color;
		lightModelfv_pname: GL_LIGHT_MODEL_AMBIENT params: lmodel_ambient;
		enable: GL_LIGHTING;
		enable: GL_LIGHT0;	"
				
	! !

!SourceCityGLVizualisationBuilder methodsFor: 'buildList' stamp: 'blo 7/9/2012 11:42'!
fillRenderingList: anOpenGLList pickingMode: aBoolean 
	(anOpenGLList = 0)
	ifTrue: [self error: 'wrong declaration'] 
	ifFalse: [
		display bindRenderBuffers.
		self checkSession.
		self openglOption: aBoolean not.
		display gl newList_list: anOpenGLList mode: GL_COMPILE.
		"display gl translatef_x: 0-((self cityDimension) first/2) asFloat y: 0 z: 0-((self cityDimension) second/2) asFloat."
		self drawCityWithPicking: aBoolean.
		display gl endList.
		].! !

!SourceCityGLVizualisationBuilder methodsFor: 'tools' stamp: 'blo 7/5/2012 14:07'!
generateId
	self id: self id +1.
	^ self id! !

!SourceCityGLVizualisationBuilder methodsFor: 'tools' stamp: 'blo 7/9/2012 12:34'!
getElementFor: anId
	^ self idDictionary at: anId ifAbsent: [nil].! !

!SourceCityGLVizualisationBuilder methodsFor: 'accessing' stamp: 'blo 7/9/2012 11:48'!
glList
	glList ifNil: [self createLists].
	^ glList! !

!SourceCityGLVizualisationBuilder methodsFor: 'accessing' stamp: 'blo 7/9/2012 11:47'!
glList: anObject

	glList := anObject! !

!SourceCityGLVizualisationBuilder methodsFor: 'accessing' stamp: 'blo 7/9/2012 11:48'!
glListPicking
	glListPicking ifNil: [self createLists].
	^ glListPicking! !

!SourceCityGLVizualisationBuilder methodsFor: 'accessing' stamp: 'blo 7/9/2012 11:46'!
glListPicking: anObject

	glListPicking := anObject! !

!SourceCityGLVizualisationBuilder methodsFor: 'accessing' stamp: 'blo 7/5/2012 14:08'!
id

	^ id! !

!SourceCityGLVizualisationBuilder methodsFor: 'accessing' stamp: 'blo 7/5/2012 14:08'!
id: anObject

	id := anObject! !

!SourceCityGLVizualisationBuilder methodsFor: 'accessing' stamp: 'blo 7/5/2012 14:08'!
idDictionary

	^ idDictionary! !

!SourceCityGLVizualisationBuilder methodsFor: 'accessing' stamp: 'blo 7/5/2012 14:08'!
idDictionary: anObject

	idDictionary := anObject! !

!SourceCityGLVizualisationBuilder methodsFor: 'initialize' stamp: 'blo 7/9/2012 12:22'!
initialize
	super initialize.
	id := 0.
	self pickingMode: false.
	! !

!SourceCityGLVizualisationBuilder methodsFor: 'drawing' stamp: 'blo 7/9/2012 11:49'!
openglOption: aBoolean
	(aBoolean)
	ifTrue: [self enableOpenGLOption] 
	ifFalse: [self disableOpenGLOption]. ! !

!SourceCityGLVizualisationBuilder methodsFor: 'accessing' stamp: 'blo 7/4/2012 16:39'!
pickingMode
	^ pickingMode! !

!SourceCityGLVizualisationBuilder methodsFor: 'accessing' stamp: 'blo 7/4/2012 16:39'!
pickingMode: anObject
	pickingMode := anObject! !

!SourceCityGLVizualisationBuilder methodsFor: 'accessing' stamp: 'blo 7/4/2012 16:39'!
selectedElement
	^ self sourceCityGL selectedElement! !

!SourceCityGLVizualisationBuilder methodsFor: 'accessing' stamp: 'blo 7/4/2012 16:39'!
selectedElement: anObject
	^ self sourceCityGL selectedElement: anObject! !

!SourceCityGLVizualisationBuilder methodsFor: 'accessing' stamp: 'blo 7/4/2012 16:39'!
sourceCityGL
	^ sourceCityGL! !

!SourceCityGLVizualisationBuilder methodsFor: 'accessing' stamp: 'blo 7/9/2012 12:25'!
sourceCityGL: anObject
	sourceCityGL := anObject.
	! !

GLViewportMorph subclass: #SourceCityGLVizualisationRenderer
	instanceVariableNames: 'pickingMode sourceCityGL'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-OpenGL'!

!SourceCityGLVizualisationRenderer class methodsFor: 'as yet unclassified' stamp: 'blo 7/9/2012 11:58'!
initialize: aSourceCityGL
	^self new sourceCityGL: aSourceCityGL
	! !

!SourceCityGLVizualisationRenderer methodsFor: 'rendering' stamp: 'blo 7/9/2012 12:27'!
adaptCameraToMorph.
	self perspectiveFovY: 100.0  
			aspect: (self sourceCityGL width /self sourceCityGL height) asFloat  
			zNear: 0.1  
			zFar: 10000.0.! !

!SourceCityGLVizualisationRenderer methodsFor: 'rendering' stamp: 'blo 7/9/2012 12:01'!
drawBackGround.		
	display gl clearColor_red: self sourceCityGL sourceCityConfiguration backgroundOpenGL red 
			green:  self sourceCityGL sourceCityConfiguration backgroundOpenGL green 
			blue:  self sourceCityGL sourceCityConfiguration backgroundOpenGL blue alpha: 0;
			clear: GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT;
			matrixMode: GL_PROJECTION; 						
			loadIdentity.! !

!SourceCityGLVizualisationRenderer methodsFor: 'accessing' stamp: 'blo 7/9/2012 12:20'!
initialize
	super initialize.
	self pickingMode: false.! !

!SourceCityGLVizualisationRenderer methodsFor: 'rendering' stamp: 'blo 7/9/2012 12:05'!
perspectiveFovY: fovY aspect: aspect zNear: zNear zFar: zFar
"Replaces gluPerspective. Sets the frustum to perspective mode.
// fovY     - Field of vision in degrees in the y direction
// aspect   - Aspect ratio of the viewport
// zNear    - The near clipping distance
// zFar     - The far clipping distance
 "
	| fW fH |
	fH := (fovY / (360 * Float pi)) tan * zNear.
	fW := fH * aspect.
	display gl frustum_left: fW negated  right:  fW bottom: fH negated top: fH  zNear:  zNear zFar:   zFar! !

!SourceCityGLVizualisationRenderer methodsFor: 'accessing' stamp: 'blo 7/9/2012 11:58'!
pickingMode

	^ pickingMode! !

!SourceCityGLVizualisationRenderer methodsFor: 'accessing' stamp: 'blo 7/9/2012 11:58'!
pickingMode: anObject

	pickingMode := anObject! !

!SourceCityGLVizualisationRenderer methodsFor: 'rendering' stamp: 'blo 7/9/2012 12:05'!
render
	| list |
	display bindRenderBuffers.
	self checkSession.
	self drawBackGround.		
	self adaptCameraToMorph.
	display gl matrixMode: GL_MODELVIEW; 
		loadIdentity.
	self sourceCityGL camera applyCamera.
	list := (pickingMode)
		ifTrue: [ self sourceCityGL drawing glListPicking ] 
		ifFalse: [ self sourceCityGL drawing glList ] .
	display gl
		callList: list;
		popMatrix;
		flush.
! !

!SourceCityGLVizualisationRenderer methodsFor: 'accessing' stamp: 'blo 7/9/2012 11:58'!
sourceCityGL

	^ sourceCityGL! !

!SourceCityGLVizualisationRenderer methodsFor: 'accessing' stamp: 'blo 7/9/2012 11:58'!
sourceCityGL: anObject

	sourceCityGL := anObject! !

NBGLFrameBuffer subclass: #GLFrameBufferForPicking
	instanceVariableNames: 'texId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-OpenGL'!

!GLFrameBufferForPicking commentStamp: '<historical>' prior: 0!
Needed for picking!

!GLFrameBufferForPicking methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 5/16/2012 15:39'!
attachTexture
	texId := WordArray new: 1.
	
" Create the texture object for the primitive information buffer "
	gl genTextures_n: 1 textures: texId.
	texId := texId at: 1.

	gl bindTexture_target: GL_TEXTURE_2D texture: texId.

	gl texImage2D_target:  GL_TEXTURE_2D level: 0  internalformat:  GL_RGB32UI 
		width: extent x  height: extent y border: 0  format: GL_RGB_INTEGER type: GL_UNSIGNED_INT pixels: nil.
	
	gl framebufferTexture2DEXT_target:  GL_DRAW_FRAMEBUFFER 
		attachment:  GL_COLOR_ATTACHMENT0 
		textarget: GL_TEXTURE_2D 
		texture:  texId  
		level: 0	.
	
	self assert: (gl getError = 0).
	gl bindTexture_target: GL_TEXTURE_2D texture: 0.! !

!GLFrameBufferForPicking methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 5/16/2012 15:21'!
createAttachments

		" By default, create a RGBA8 and DEPTH24/STENCIL8 attachments "
	| color depthAndStencil |
	
	self attachTexture.

	
	depthAndStencil := NBGLRenderBuffer gl: gl extent: extent format: GL_DEPTH24_STENCIL8.
	self attach: depthAndStencil as: GL_DEPTH_ATTACHMENT.
	self attach: depthAndStencil as: GL_STENCIL_ATTACHMENT.
	
! !

!GLFrameBufferForPicking methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 5/16/2012 15:23'!
resize: newExtent

	"resize a frame buffer"
	extent = newExtent ifTrue: [ ^ self ].
	extent := newExtent.	

	self attachments do: [:renderBuffer | renderBuffer resize: newExtent  ].
	self resizeTexture.
	self checkStatus.

! !

!GLFrameBufferForPicking methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 5/16/2012 15:23'!
resizeTexture

	gl bindTexture_target: GL_TEXTURE_2D texture: texId.

	gl texImage2D_target:  GL_TEXTURE_2D level: 0  internalformat:  GL_RGB32UI 
		width: extent x  height: extent y border: 0  format: GL_RGB_INTEGER type: GL_UNSIGNED_INT pixels: nil.
! !

Object subclass: #Point3D
	instanceVariableNames: 'x y z'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-OpenGL'!

!Point3D class methodsFor: 'as yet unclassified' stamp: 'blo 7/4/2012 15:58'!
x: x y: y z: z
	^ self new x: x; y: y; z: z; yourself! !

!Point3D methodsFor: 'as yet unclassified' stamp: 'blo 7/5/2012 16:03'!
+ aPoint3D
	^ Point3D x: (x + aPoint3D x) y: (y + aPoint3D y) z: (z + aPoint3D z)! !

!Point3D methodsFor: 'as yet unclassified' stamp: 'blo 7/5/2012 15:15'!
copy
	^ self class x: x y: y z: z! !

!Point3D methodsFor: 'accessing' stamp: 'blo 7/4/2012 15:56'!
x

	^ x! !

!Point3D methodsFor: 'accessing' stamp: 'blo 7/4/2012 15:56'!
x: anObject

	x := anObject! !

!Point3D methodsFor: 'accessing' stamp: 'blo 7/4/2012 15:56'!
y

	^ y! !

!Point3D methodsFor: 'accessing' stamp: 'blo 7/4/2012 15:56'!
y: anObject

	y := anObject! !

!Point3D methodsFor: 'accessing' stamp: 'blo 7/4/2012 15:56'!
z

	^ z! !

!Point3D methodsFor: 'accessing' stamp: 'blo 7/4/2012 15:56'!
z: anObject

	z := anObject! !

Object subclass: #SourceCityGLCamera
	instanceVariableNames: 'lastMousePosition position orientation sourceCityGL'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-OpenGL'!

!SourceCityGLCamera commentStamp: '<historical>' prior: 0!
I manage the camera and movements (do not contains key/mouse handler stuff)!

!SourceCityGLCamera class methodsFor: 'as yet unclassified' stamp: 'blo 7/5/2012 15:37'!
initialize: aSourceCityGL camera: aCamera
	
	^self new sourceCityGL: aSourceCityGL; defineDefaultCamera: aCamera! !

!SourceCityGLCamera methodsFor: 'camera' stamp: 'blo 7/5/2012 15:28'!
applyCamera
	self sourceCityGL display gl translatef_x: (self position x) y: (self position y) z: (self position z).  
	self sourceCityGL display gl  rotatef_angle: (self orientation x) x: 1 y: 0  z: 0. 
	self sourceCityGL display gl rotatef_angle: (self orientation y) x: 0 y: 1  z: 0. 
	self sourceCityGL display gl rotatef_angle: (self orientation z) x: 0 y: 0  z: 1. 
	 
! !

!SourceCityGLCamera methodsFor: 'camera' stamp: 'blo 7/5/2012 15:23'!
cameraOnNormal
	self defineDefaultCamera: sourceCityGL sourceCityConfiguration camera.
	 ! !

!SourceCityGLCamera methodsFor: 'camera' stamp: 'blo 7/5/2012 15:42'!
cameraOnTop
	self position: (Point3D x: 0 y: 0 z: (0 - self sourceCityGL sourceCityConfiguration city width *7)).
	self orientation: (Point3D x: -631 y: -900 z: 0).! !

!SourceCityGLCamera methodsFor: 'camera' stamp: 'blo 7/5/2012 15:23'!
defineDefaultCamera: aCamera
	orientation := aCamera orientation.
	position := aCamera position.! !

!SourceCityGLCamera methodsFor: 'initialize' stamp: 'blo 7/5/2012 15:17'!
initialize
	super initialize.
	lastMousePosition := Point x: 0 y:0.! !

!SourceCityGLCamera methodsFor: 'accessing' stamp: 'blo 7/5/2012 14:35'!
lastMousePosition

	^ lastMousePosition! !

!SourceCityGLCamera methodsFor: 'accessing' stamp: 'blo 7/5/2012 14:35'!
lastMousePosition: anObject

	lastMousePosition := anObject! !

!SourceCityGLCamera methodsFor: 'accessing' stamp: 'blo 7/5/2012 15:10'!
orientation

	^ orientation! !

!SourceCityGLCamera methodsFor: 'accessing' stamp: 'blo 7/5/2012 15:10'!
orientation: anObject

	orientation := anObject! !

!SourceCityGLCamera methodsFor: 'accessing' stamp: 'blo 7/5/2012 15:19'!
position

	^ position! !

!SourceCityGLCamera methodsFor: 'accessing' stamp: 'blo 7/5/2012 15:19'!
position: anObject

	position := anObject! !

!SourceCityGLCamera methodsFor: 'camera' stamp: 'blo 7/5/2012 15:42'!
rotateDown

	self orientation x: (self orientation x + 3).
	! !

!SourceCityGLCamera methodsFor: 'camera' stamp: 'blo 7/5/2012 15:43'!
rotateLeft

	self orientation y: (self orientation y + 3).
	! !

!SourceCityGLCamera methodsFor: 'camera' stamp: 'blo 7/5/2012 15:43'!
rotateRight

	self orientation y: (self orientation y - 3).
	! !

!SourceCityGLCamera methodsFor: 'camera' stamp: 'blo 7/5/2012 15:43'!
rotateTop

	self orientation x: (self orientation x - 3).
	! !

!SourceCityGLCamera methodsFor: 'accessing' stamp: 'blo 7/5/2012 15:19'!
sourceCityGL

	^ sourceCityGL! !

!SourceCityGLCamera methodsFor: 'accessing' stamp: 'blo 7/5/2012 15:37'!
sourceCityGL: anObject

	sourceCityGL := anObject.! !

!SourceCityGLCamera methodsFor: 'camera' stamp: 'blo 7/5/2012 15:44'!
translateBackward

	self position z: (self position z - 3).
	
	! !

!SourceCityGLCamera methodsFor: 'camera' stamp: 'blo 7/5/2012 15:44'!
translateDown

	self position y: (self position y + 3).! !

!SourceCityGLCamera methodsFor: 'camera' stamp: 'blo 7/5/2012 15:44'!
translateForward

	self position z: (self position z + 3).
	! !

!SourceCityGLCamera methodsFor: 'camera' stamp: 'blo 7/5/2012 15:45'!
translateLeft

	self position x: (self position x - 3).
	! !

!SourceCityGLCamera methodsFor: 'camera' stamp: 'blo 7/5/2012 15:45'!
translateRight

	self position x: (self position x + 3).
	! !

!SourceCityGLCamera methodsFor: 'camera' stamp: 'blo 7/5/2012 15:45'!
translateTop

	self position y: (self position y - 3).
	! !

Object subclass: #SourceCityGLController
	instanceVariableNames: 'sourceCityGL mouseDown'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-OpenGL'!

!SourceCityGLController commentStamp: '<historical>' prior: 0!
I manage and capture keyboard and mouse events!

!SourceCityGLController class methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 6/21/2012 13:03'!
initialize: aSourceCityGL
	^self new sourceCityGL: aSourceCityGL! !

!SourceCityGLController methodsFor: 'control' stamp: 'DouailleErwan 6/28/2012 10:17'!
captureKey: e
	(e keyString = '<left>')
		ifTrue:[ self sourceCityGL camera rotateLeft].
	(e keyString  = '<down>')
		ifTrue:[self sourceCityGL camera rotateDown].
	(e keyString  = '<up>')
		ifTrue:[self sourceCityGL camera rotateTop].
	(e keyString  = '<right>')
		ifTrue:[self sourceCityGL camera rotateRight].
	(e keyString  = '<Shift-right>')
		ifTrue:[self sourceCityGL camera translateRight].
	(e keyString  = '<Shift-left>')
		ifTrue:[self sourceCityGL camera translateLeft].
	(e keyString  = '<Shift-up>')
		ifTrue:[self sourceCityGL camera translateTop].
	(e keyString  = '<Shift-down>')
		ifTrue:[self sourceCityGL camera translateDown].
	(e keyString  = ' ')
		ifTrue:[self sourceCityGL camera translateForward].
	(e keyString  = 'c' )
		ifTrue:[self sourceCityGL camera translateBackward].
	(e keyString  = '<Cmd-w>' )
		ifTrue:[Transcript cr;show: ' dommage'].! !

!SourceCityGLController methodsFor: 'control' stamp: 'blo 7/9/2012 12:34'!
captureMouseDown: e
	mouseDown ifTrue: [
	self sourceCityGL renderer pickingMode: true.
	self sourceCityGL renderer render.
	self picking_x: ((e position x) - self sourceCityGL position x) y: ((e position y) - self sourceCityGL position y).
	self sourceCityGL renderer pickingMode: false.].

	mouseDown:= mouseDown not.! !

!SourceCityGLController methodsFor: 'control' stamp: 'DouailleErwan 6/26/2012 17:04'!
captureMouseStillDown: e
	(self sourceCityGL camera  lastMousePosition x > (e position - self sourceCityGL position) x)
		ifTrue: [self sourceCityGL camera  rotateRight].
	(self sourceCityGL camera  lastMousePosition x < (e position - self sourceCityGL  position) x)
		ifTrue:[self sourceCityGL camera  rotateLeft].
	(self sourceCityGL camera  lastMousePosition y < (e position - self sourceCityGL position) y)
		ifTrue:[self sourceCityGL camera  rotateDown].
	(self sourceCityGL camera  lastMousePosition y > (e position - self sourceCityGL position) y)
		ifTrue:[self sourceCityGL camera  rotateTop].
	self sourceCityGL camera  lastMousePosition: (e position - self sourceCityGL position).! !

!SourceCityGLController methodsFor: 'control' stamp: 'DouailleErwan 6/22/2012 15:29'!
handleMouseMove: anEvent
	"System level event handling."
	anEvent wasHandled ifTrue:[^self]. "not interested"
	anEvent wasHandled: true.
	anEvent anyButtonPressed ifTrue: [
		self captureMouseStillDown: anEvent
		].
! !

!SourceCityGLController methodsFor: 'control' stamp: 'DouailleErwan 6/18/2012 15:26'!
hasKeyboardFocus
	^true.! !

!SourceCityGLController methodsFor: 'initialize-release' stamp: 'blo 7/9/2012 12:32'!
initialize
	super initialize.
	mouseDown:= false.! !

!SourceCityGLController methodsFor: 'control' stamp: 'blo 7/9/2012 12:36'!
picking_x: x y: y
	|  pixel id tmp |
	pixel := self sourceCityGL display readPixel: x@y.	
	id := (pixel at:1)*256 + (pixel at:2)*256 + (pixel at:3).
	Transcript show: (self sourceCityGL drawing getElementFor: id) name.
	self flag: 'TODO send element to user interface'! !

!SourceCityGLController methodsFor: 'accessing' stamp: 'DouailleErwan 6/18/2012 15:39'!
sourceCityGL
	^ sourceCityGL! !

!SourceCityGLController methodsFor: 'accessing' stamp: 'DouailleErwan 6/18/2012 15:39'!
sourceCityGL: anObject
	sourceCityGL := anObject! !
